#include "stdafx.h"

sprite fire_gradient;

int fire_brightness[82][51] = {0,};

double rot_x = 0;
double rot_y = 0;

int cube_bright = 63;

bool fire_init() {
	if (!load_sprite("data/fire.spr",&fire_gradient)) {
		return false;
	}
	return true;
}
bool fire_shut_down() {
	free_sprite(fire_gradient);
	return true;
}

int time_for_ani = 0;


void draw_pixel(int x, int y) {
	if (x>=0 && x<80 && y>=0 && y<50) {
		fire_brightness[x+1][y] = cube_bright;
	}
}

void draw_line(int x1, int y1, int x2, int y2) {
	int deltax = abs(x2 - x1);
	int deltay = abs(y2 - y1);
	int x = x1;	int y = y1;
	int xinc1;	int xinc2;
	int yinc1;	int yinc2;
	int den;	int num;
	int numadd;	int numpixels;

	if (x2>=x1) {
		xinc1 = 1; xinc2 = 1;
	} else {
		xinc1 = -1; xinc2 = -1;
	}

	if (y2>=y1) {
		yinc1 = 1; yinc2 = 1;
	} else {
		yinc1 = -1; yinc2 = -1;
	}

	if (deltax>=deltay) {
		xinc1 = 0;
		yinc2 = 0;
		den = deltax;
		num = deltax / 2;
		numadd = deltay;
		numpixels = deltax;
	} else {
		xinc2 = 0;
		yinc1 = 0;
		den = deltay;
		num = deltay / 2;
		numadd = deltax;
		numpixels = deltay;
	}

	for (int curpixel=0; curpixel<=numpixels; curpixel++) {
		draw_pixel(x,y);
		num += numadd;
		if (num >= den) {
			num -= den;
			x += xinc1;
			y += yinc1;
		}
		x += xinc2;
		y += yinc2;
	}

}

void draw_3D_line(int x1, int y1, int z1, int x2, int y2, int z2) {

	double x_p[2] = {(double)x1, (double)x2};
	double y_p[2] = {(double)y1, (double)y2};
	double z_p[2] = {(double)z1, (double)z2};
	int scrX[2];
	int scrY[2];

	for (int i=0; i<2; ++i) {
		double rotX1 = -x_p[i] * sin(rot_x) + y_p[i] * cos(rot_x);
		double rotY1 = -x_p[i] * cos(rot_x) * sin(rot_y) - y_p[i] * sin(rot_x) * sin(rot_y) - z_p[i] * cos(rot_y);
		double rotZ1 = -x_p[i] * cos(rot_x) * cos(rot_y) - y_p[i] * sin(rot_x) * cos(rot_y) + z_p[i] * sin(rot_y);
		scrX[i] = (int)(256 * (rotX1 / (rotZ1 + 256)) + 40);
		scrY[i] = (int)(256 * (rotY1 / (rotZ1 + 256)) + 25);
	}

	draw_line(scrX[0],scrY[0],scrX[1],scrY[1]);
}

void fire_draw_frame(int time) {

	CHAR_INFO *d = console_buffer;

	for (int y=0; y<50; ++y) for (int x=0; x<80; ++x) {
		*d++ =
			palette
			[
				colour_map
				[
					fire_gradient.data
					[
						fire_brightness[x][y]
					]*256
				]
			];
	}


	time_for_ani+=time;

	if (time_for_ani>=18) {

		// Draw dat cube

		draw_3D_line(-15,-15,-15, 15,-15,-15);
		draw_3D_line( 15,-15,-15, 15, 15,-15);
		draw_3D_line( 15, 15,-15,-15, 15,-15);
		draw_3D_line(-15, 15,-15,-15,-15,-15);

		draw_3D_line(-15,-15, 15, 15,-15, 15);
		draw_3D_line( 15,-15, 15, 15, 15, 15);
		draw_3D_line( 15, 15, 15,-15, 15, 15);
		draw_3D_line(-15, 15, 15,-15,-15, 15);

		draw_3D_line(-15,-15, 15,-15,-15,-15);
		draw_3D_line( 15,-15, 15, 15,-15,-15);
		draw_3D_line( 15, 15, 15, 15, 15,-15);
		draw_3D_line(-15, 15, 15,-15, 15,-15);

		rot_x+=0.04;
		rot_y+=0.02;

		cube_bright = (int)(16*sin(rot_x*cos(rot_y)/8))+47;

		time_for_ani = 0;
		for (int y=0; y<50; ++y) {
			for (int x=1; x<81; ++x) {
				fire_brightness[x][y] = 
					(fire_brightness[x][y+1]+
					fire_brightness[x-1][y+1]+
					fire_brightness[x+1][y+1]+
					fire_brightness[x][y])/4;
				if (fire_brightness[x][y]) fire_brightness[x][y]+=(4-rand()%8);
				--fire_brightness[x][y];
				if (fire_brightness[x][y]<0) fire_brightness[x][y] = 0;
				if (fire_brightness[x][y]>=fire_gradient.w) fire_brightness[x][y] = fire_gradient.w-1;
	
			}
			
		}

	}

	
}
