#include "stdafx.h"

int plasma_table[512];

int plasma_palette[512];

bool plasma_init() {
	for (int i=0; i<512; ++i) {
		plasma_table[i] = 128+(int)(127*sin(((double)i)/6.283185307179586476925286766559));
		plasma_palette[i] = find_closest_colour(plasma_table[(i/2)&511],plasma_table[(i/4)&511],plasma_table[(i*1)&511]);
	}
	return true;
}
bool plasma_shut_down() {
	return true;
}

double pl_a = 0, pl_b = 0, pl_c = 0;

void plasma_draw_frame(int time) {

	CHAR_INFO *t = console_buffer;
	for (int y=0; y<50; ++y) {
		for (int x=0; x<80; ++x) {
			double r = 1+((double)plasma_table[((int)(pl_a/64)) & 511]/128);
			double p_r = plasma_table[(int)((double)x/r-pl_a/64) & 511];
			double p_g = plasma_table[(int)((double)y/r+pl_b/64) & 511];
			double p_b = plasma_table[(int)((double)x/r-y+pl_c/64) & 511];
			*t++ = palette[plasma_palette[((int)(((p_r+p_g+p_b)/6)+pl_a/32))&511]];
		}
	}
	pl_a+=time;
	pl_b+=time*2;
	pl_c+=time*3;

}